<template>
    <div class="cont">
        <v-card color="primary" width="30%" class="mx-auto a white--text pa-6">
            <v-form>
                <div class="headline pt-7">欢迎来到cocode！</div>
                <div class="caption">一个崭新的世界，即将对你开放……</div>
                <v-text-field
                    label="用户名"
                    color="secondary"
                    outlined
                    dense
                    class="mt-10"
                    clearable
                    dark
                    v-model.trim="userName"
                ></v-text-field>
                <v-text-field
                    label="昵称"
                    color="secondary"
                    outlined
                    dense
                    class="mt-10"
                    clearable
                    dark
                    v-model.trim="nickName"
                ></v-text-field>
                <v-text-field
                    label="密码"
                    type="password"
                    color="secondary"
                    outlined
                    dense
                    clearable
                    dark
                    v-model.trim="password"
                ></v-text-field>
                <v-text-field
                    label="确认密码"
                    type="password"
                    color="secondary"
                    outlined
                    dense
                    @keyup.enter="register"
                    :error="alert"
                    :error-messages="errorMessage"
                    clearable
                    dark
                    v-model.trim="passwordRepeat"
                ></v-text-field>
                <div class="rightwrap">
                    <v-btn color="accent" class="mt-3" @click="register">注册!</v-btn>
                </div>
            </v-form>
        </v-card>
    </div>
</template>

<script>
import hash from "../../../node_modules/sha.js";
export default {
    name: "RegisterPage",
    components: {},
    computed: {
        passwordHash() {
            return hash("sha256")
                .update(this.password)
                .digest("hex");
        },
    },
    methods: {
        register() {
            if (this.userName === "") {
                this.register_alert("用户名不能为空！");
                return;
            }

            if(this.userName.length > 10){
                this.register_alert("用户名不能超过10个字符！");
                return;
            }

            if (this.nickName === "") {
                this.register_alert("昵称不能为空！");
                return;
            }

            if(this.nickName.length > 10){
                this.register_alert("昵称不能超过10个字符！");
                return;
            }

            if (!this.password.length) {
                this.register_alert("密码不能为空！");
                return;
            }

            if(this.password.length > 20){
                this.register_alert("密码不能超过20个字符！");
                return;
            }

            if (this.password !== this.passwordRepeat) {
                this.register_alert("重复密码与密码不一致！");
                return;
            }

            this.$axios({
                method: "post",
                url: `/register`,
                data: {
                    userName: this.userName,
                    password: this.passwordHash,
                    nickName: this.nickName,
                },
            })
                .then(res => {
                    if (res.status === 200) {
                        const data = res.data;
                        if (data.status === "GET_SUCCESS") {
                            //this.$store.dispatch('register')
                            this.$router.push("/");
                        } else if (data.status === "USERNAME_DUPLICATE") {
                            this.register_alert("用户名已存在！");
                        } else {
                            this.register_alert("出错了！");
                        }
                    } else {
                        this.register_alert("连接失败。\n请检查您的网络状态。");
                    }
                })
                .catch(e => {
                    this.register_alert(e);
                });
        },
        register_alert(message) {
            this.errorMessage = "" + message;
        },
    },
    data: () => ({
        userName: "",
        nickName: "",
        password: "",
        passwordRepeat: "",
        errorMessage: "",
        alert: false,
    }),
};
</script>

<style scoped>
.cont {
    background-color: #f4ff91;
    background-image: url(../../../public/logo_bgr.png);
    background-repeat: space;
    height: 100%;
    width: 100%;
}
.a {
    top: 5%;
    position: relative;
}
.rightwrap {
    display: flex;
    justify-content: flex-end;
}
</style>
